﻿namespace TabsStudioAutoOpener
{
    class WindowsMonitor
    {
        public WindowsMonitor(TabsStudioExt.ITabsStudioEngine engine_)
        {
            engine = engine_;
            openedWindows = new System.Collections.Generic.List<EnvDTE.Window>();
            saving = true;

            engine.TabExtensionCreated += OnExtensionCreated;
            engine.TabExtensionDestroyed += OnExtensionDestroyed;
        }

        public void Close()
        {
            engine.TabExtensionCreated -= OnExtensionCreated;
            engine.TabExtensionDestroyed -= OnExtensionDestroyed;
        }

        public bool IsOpened(EnvDTE.Window w)
        {
            return openedWindows.Contains(w);
        }

        private void OnExtensionCreated(object sender, TabsStudioExt.TabExtensionEventArgs e)
        {
            saving = false;
        }

        private void OnExtensionDestroyed(object sender, TabsStudioExt.TabExtensionEventArgs e)
        {
            if (!saving)
            {
                openedWindows.Clear();
                saving = true;
            }

            openedWindows.Add(e.TabExtension.Window);
        }

        private TabsStudioExt.ITabsStudioEngine engine;
        private System.Collections.Generic.List<EnvDTE.Window> openedWindows;
        private bool saving;
    }
}
